{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //IOEvent:{routeName:'BaseController-getComboValues',table:'io_events',options:{where:'O'}}
            //,IOEventG:{routeName:'BaseController-getComboValues',table:'io_events',options:{where:'O'}}
        },
        rendererauthorize:function(val){
            if(val=='ismaintenance') return "{{ 'LostType.ismaintenance'|trans }}";
            if(val=='ismould') return "{{ 'LostType.ismould'|trans }}";
            if(val=='isquality') return "{{ 'LostType.isquality'|trans }}";
            if(val=='isoperator') return "{{ 'LostType.isoperator'|trans }}";
            if(val=='isexpert') return "{{ 'LostType.isexpert'|trans }}";
            return '';
        },
        _onButtonSaveAsXLSClick:function(){
            var t = this;
            if (t.modulename && typeof Routing !== 'undefined') {
                t.waitMaskShow();
                var routeName = 'Reports-add';
                var route = Routing.getRoute(routeName);
                var pagerParams = {'pg':1,'lm':25};
                var url = Routing.generate(routeName, pagerParams);
                if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                    $.ajax({
                        url: url,
                        method: "POST",
                        headers: { 
                            "Content-Type": "application/json",
                            "X-HTTP-Method-Override": route.methods[0] 
                        },
                        data: JSON.stringify({reportname:'LostTypeAll'}),
                        dataType: 'binary',
                        processData: false,
                        success: function(data, textStatus, xhr) {
                            //t.activateTabGrid();
                            if(textStatus==='success'){
                                var filename = "";
                                var disposition = xhr.getResponseHeader('Content-Disposition');
                                if (disposition && disposition.indexOf('attachment') !== -1) {
                                    var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
                                    var matches = filenameRegex.exec(disposition);
                                    if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
                                }
                                var type = xhr.getResponseHeader('Content-Type');
                                var blob = typeof File === 'function'
                                    ? new File([data], filename, { type: type })
                                    : new Blob([data], { type: type });
                                if (typeof window.navigator.msSaveBlob !== 'undefined') {
                                    // IE workaround for "HTML7007: One or more blob URLs were revoked by closing the blob for which they were created. These URLs will no longer resolve as the data backing the URL has been freed."
                                    window.navigator.msSaveBlob(blob, filename);
                                    t.waitMaskHide();
                                } else {
                                    var URL = window.URL || window.webkitURL;
                                    var downloadUrl = URL.createObjectURL(blob);
                                    if (filename) {
                                        // use HTML5 a[download] attribute to specify filename
                                        var a = document.createElement("a");
                                        // safari doesn't support this yet
                                        if (typeof a.download === 'undefined') {
                                            window.location = downloadUrl;
                                            t.waitMaskHide();
                                        } else {
                                            a.href = downloadUrl;
                                            a.download = filename;
                                            document.body.appendChild(a);
                                            a.click();
                                            t.waitMaskHide();
                                        }
                                    } else {
                                        window.location = downloadUrl;
                                        t.waitMaskHide();
                                    }

                                    setTimeout(function () { URL.revokeObjectURL(downloadUrl); }, 100); // cleanup
                                }
                            }
                        },
                        error: function(xhr, textStatus, errorThrown) {
                            t.waitMaskHide();
                            if(xhr.responseJSON&&xhr.responseJSON.message){
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: xhr.responseJSON.message,
                                    type: "error",
                                    html: true
                                });
                            }
                        },
                        complete: function(jqXHR, textStatus) {
                            t.waitMaskHide();
                        }
                    });
                }
            }
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.stores.authorizeloststart=new mj.store({
                data:[{id:'ismaintenance',code:"{{ 'LostType.ismaintenance'|trans }}"}
                    ,{id:'ismould',code:"{{ 'LostType.ismould'|trans }}"}
                    ,{id:'isquality',code:"{{ 'LostType.isquality'|trans }}"}
                    ,{id:'isoperator',code:"{{ 'LostType.isoperator'|trans }}"}
                    ,{id:'isexpert',code:"{{ 'LostType.isexpert'|trans }}"}
                ]
            });
            t.stores.authorizelostfinish=new mj.store({
                data:[{id:'ismaintenance',code:"{{ 'LostType.ismaintenance'|trans }}"}
                    ,{id:'ismould',code:"{{ 'LostType.ismould'|trans }}"}
                    ,{id:'isquality',code:"{{ 'LostType.isquality'|trans }}"}
                    ,{id:'isoperator',code:"{{ 'LostType.isoperator'|trans }}"}
                    ,{id:'isexpert',code:"{{ 'LostType.isexpert'|trans }}"}
                ]
            });
            t.stores.authorizeloststartG=new mj.store({
                data:[{id:'ismaintenance',code:"{{ 'LostType.ismaintenance'|trans }}"}
                    ,{id:'ismould',code:"{{ 'LostType.ismould'|trans }}"}
                    ,{id:'isquality',code:"{{ 'LostType.isquality'|trans }}"}
                    ,{id:'isoperator',code:"{{ 'LostType.isoperator'|trans }}"}
                    ,{id:'isexpert',code:"{{ 'LostType.isexpert'|trans }}"}
                ]
            });
            t.stores.authorizelostfinishG=new mj.store({
                data:[{id:'ismaintenance',code:"{{ 'LostType.ismaintenance'|trans }}"}
                    ,{id:'ismould',code:"{{ 'LostType.ismould'|trans }}"}
                    ,{id:'isquality',code:"{{ 'LostType.isquality'|trans }}"}
                    ,{id:'isoperator',code:"{{ 'LostType.isoperator'|trans }}"}
                    ,{id:'isexpert',code:"{{ 'LostType.isexpert'|trans }}"}
                ]
            });
            const gridConfig = {
                cm: [
                    {header: "{{ 'LostType.listorder'|trans }}", dataIndex: 'listorder', width: 40,alias:'lt'},
                    {header: "{{ 'LostType.code'|trans }}", dataIndex: 'code', width: 150,filter:'between',alias:'lt'},
                    {header: "{{ 'LostType.extcode'|trans }}", dataIndex: 'extcode', width: 100,filter:'between',alias:'lt'},
                    {header: "{{ 'LostType.ioevent'|trans }}", dataIndex: 'ioevent', width: 100,filter:'single', type:'combo',store:t.extras.io_events,alias:'lt',operator:'='},
                    {header: "{{ 'LostType.time'|trans }}", dataIndex: 'time', width: 60,alias:'lt'},
                    {header: "{{ 'LostType.authorizeloststart'|trans }}", dataIndex: 'authorizeloststart', width: 90,filter:'single', type:'combo',store:t.stores.authorizeloststartG,alias:'lt',operator:'=',renderer:t.rendererauthorize},
                    {header: "{{ 'LostType.authorizelostfinish'|trans }}", dataIndex: 'authorizelostfinish', width: 90,filter:'single', type:'combo',store:t.stores.authorizelostfinishG,alias:'lt',operator:'=',renderer:t.rendererauthorize},
                    //{header: "{{ 'LostType.isemployeerequired'|trans }}", dataIndex: 'isemployeerequired', width: 60,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'},
                    //{header: "{{ 'LostType.isexpertemployeerequired'|trans }}", dataIndex: 'isexpertemployeerequired', width: 80,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'},
                    //{header: "{{ 'LostType.isoperationnumberrequired'|trans }}", dataIndex: 'isoperationnumberrequired', width: 60,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'},
                    {header: "{{ 'LostType.isclient'|trans }}", dataIndex: 'isclient', width: 80,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'},
                    {header: "{{ 'LostType.isemployee'|trans }}", dataIndex: 'isemployee', width: 80,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'},
                    {header: "{{ 'LostType.closenoemployee'|trans }}", dataIndex: 'closenoemployee', width: 120,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'},
                    {header: "{{ 'LostType.isopenallports'|trans }}", dataIndex: 'isopenallports', width: 120,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'},
                    {header: "{{ 'LostType.islisted'|trans }}", dataIndex: 'islisted', width: 110,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'}
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.numberField({
                        title : "{{ 'LostType.listorder'|trans }}",
                        dataIndex : 'listorder',
                        labelWidth : '110px',
                        width : 50
                    }),
                    new mj.form.textField({
                        title: "{{ 'LostType.code'|trans }}",
                        dataIndex: 'code',
                        maxLength: 50,
                        labelWidth : '110px',
                        width:200,
                        grid: 's4 m2'
                    }),
                    new mj.form.textField({
                        title: "{{ 'LostType.extcode'|trans }}",
                        dataIndex: 'extcode',
                        maxLength: 50,
                        labelWidth : '130px',
                        width:200,
                        grid: 's4 m2',
                        right:true
                    }),
                    new mj.form.textField({
                        title: "{{ 'LostType.description'|trans }}",
                        dataIndex: 'description',
                        maxLength: 255,
                        labelWidth : '110px',
                        width:200,
                        grid: 's12 m6'
                    }),
                    new mj.form.combo({
                        title: "{{ 'LostType.ioevent'|trans }}",
                        placeHolder: "{{ 'LostType.ioevent_placeholder'|trans }}",
                        dataIndex: 'ioevent',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '110px',
                        grid: 's6 m4',
                        store: t.extras.io_events
                    }),
                    new mj.form.combo({
                        title: "{{ 'LostType.authorizeloststart'|trans }}",
                        placeHolder: "{{ 'LostType.authorizeloststart'|trans }}",
                        dataIndex: 'authorizeloststart',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        sameValueDisplay:false,
                        labelWidth : '110px',
                        grid: 's6 m4',
                        width: 150,
                        store: t.stores.authorizeloststart
                    }),
                    new mj.form.combo({
                        title: "{{ 'LostType.authorizelostfinish'|trans }}",
                        placeHolder: "{{ 'LostType.authorizelostfinish'|trans }}",
                        dataIndex: 'authorizelostfinish',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        sameValueDisplay:false,
                        labelWidth : '110px',
                        grid: 's6 m4',
                        width: 150,
                        store: t.stores.authorizelostfinish,
                        right:true
                    }),
                    //new mj.form.checkBox({
                    //    title: "{{ 'LostType.isemployeerequired'|trans }}",
                    //    dataIndex: 'isemployeerequired',
                    //    itemStyle: 'padding:0 35px 0 0;float:left;',
                    //    labelWidth : '110px',
                    //    grid: 'none'
                    //}),
                    //new mj.form.checkBox({
                    //    title: "{{ 'LostType.isexpertemployeerequired'|trans }}",
                    //    dataIndex: 'isexpertemployeerequired',
                    //    itemStyle: 'padding:0 35px 0 0;float:left;',
                    //    labelWidth : '110px',
                    //    grid: 'none'
                    //}),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.isoperationnumberrequired'|trans }}",
                        dataIndex: 'isoperationnumberrequired',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '110px',
                        grid: 'none'
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.closenoemployee'|trans }}",
                        dataIndex: 'closenoemployee',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '150px',
                        grid: 'none',
                        right:true
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.isopenallports'|trans }}",
                        dataIndex: 'isopenallports',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '150px',
                        grid: 'none',
                        right:true
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.isclient'|trans }}",
                        dataIndex: 'isclient',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '110px',
                        grid: 'none'
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.isemployee'|trans }}",
                        dataIndex: 'isemployee',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '150px',
                        grid: 'none',
                        right:true
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.islisted'|trans }}",
                        dataIndex: 'islisted',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '150px',
                        grid: 'none',
                        right:true
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.isdescriptionrequired'|trans }}",
                        dataIndex: 'isdescriptionrequired',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '110px',
                        grid: 'none'
                    }),
                    new mj.form.numberField({
                        title: "{{ 'LostType.time'|trans }}",
                        dataIndex: 'time',
                        width : 50,
                        maxLength: 10,
                        labelWidth : '110px',
                        grid: 's12 m6'
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.isshortlost'|trans }}",
                        dataIndex: 'isshortlost',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '110px',
                        grid: 's12 m6'
                    }),
                    new mj.form.checkBox({
                        title: "{{ 'LostType.issourcelookup'|trans }}",
                        dataIndex: 'issourcelookup',
                        itemStyle: 'padding:0 35px 0 0;float:left;',
                        labelWidth : '180px',
                        grid: 's12 m6',
                        right:true
                    }),
                    new mj.form.dateField({
                        title: "{{ 'LostType.start'|trans }}",
                        dataIndex: 'start',
                        labelWidth : '110px',
                        notEmpty: true,
                        grid: 's4 m2'
                    }),
                    new mj.form.dateField({
                        title: "{{ 'LostType.finish'|trans }}",
                        dataIndex: 'finish',
                        labelWidth : '110px',
                        grid: 's4 m2'
                    })
                ]
            };
            t._setFormConfig(formConfig);

            if(typeof t.grids.main.pbar.tbar.addSplitter==='function'){
				t.grids.main.pbar.tbar.addSplitter();
			}
            t.buttons.saveAsXLS = t.grids.main.pbar.tbar.addButton({
                alt: mj.lng.glb.saveAsXLS,
                cls: 'btn-sm left',
                iconCls: 'mj-save-as-xls',
                scope: t,
                handler: t._onButtonSaveAsXLSClick
			});
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
